<?php
/**
 * @package	Memberpages
 * @copyright	Copyright (c) 2012-2015 svasti <http://svasti.de>
 *
 */

if ((!function_exists('sv')) || preg_match('!admin.php!i', sv('PHP_SELF')))die('Access denied');

if (!defined('CMSIMPLE_URL')) {
    define(
        'CMSIMPLE_URL',
        'http'
        . (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != 'off' ? 's' : '')
        . '://' . $_SERVER['HTTP_HOST'] . $sn
    );
}

if($plugin_cf['memberpages']['membersfilepath']) {
    define('MEMBERSFILEPATH', $pth['folder']['base'] . rtrim($plugin_cf['memberpages']['membersfilepath'],'/').'/');
} else {
    define('MEMBERSFILEPATH', $pth['folder']['userfiles'].'plugins/memberpages/');
}

include_once 'memberlist.php';

if (preg_match("!Googlebot!i",$_SERVER['HTTP_USER_AGENT']));
else if (preg_match("!MSNbot!i",$_SERVER['HTTP_USER_AGENT']));
else if (preg_match("!slurp!i",$_SERVER['HTTP_USER_AGENT']));
else if (!isset($_SESSION)) {session_start();}
@header("Cache-Control: no-cache, must-revalidate");
$plugin = basename(dirname(__FILE__),"/");

//if php 4 is used, this function has to be supplied (by cmb)
if (!function_exists('file_put_contents')) {
    function file_put_contents($filename, $data) {
        $f = @fopen($filename, 'w');
        if (!$f) {
            return false;
        } else {
        if (is_array($data)) {$data = implode('', $data);}
            $bytes = fwrite($f, $data);
            fclose($f);
            return $bytes;
        }
    }
}
if (!function_exists('XH_hsc')) {
    function XH_hsc($str) {
        return htmlspecialchars($str);
    }
}
//get memberslist
$member = parse_ini_file(MEMBERSFILEPATH.'membersfile.php',true);

//hide pages via pdtabs
if($plugin_cf['memberpages']['pdtab']) memberpages_HidePages();

//hide pages via CMSimple scripting
if($plugin_cf['memberpages']['texttrigger']) {
    include_once 'oldfuncs.php';
    memberpages_OldStyleHide();
}

// automatic log in
if($plugin_cf['memberpages']['rememberme'])
{
    if(isset($_COOKIE['cookname']) && isset($_COOKIE['cookpass']))
    {
        if(!isset($_SESSION['username']))$function='memberslogin';
    }
}

// PASSWORD FORGOTTEN
initvar('password_forgotten');
if(isset($_POST['stoppwforgotten'])) $password_forgotten = $function = '';
if($password_forgotten) $o .= memberpages_PwForgotten();

// Register Me
initvar('register_me');
if(isset($_POST['stopregister_me'])) $register_me = $function = '';
if($register_me) $o .= memberpages_RegisterMe();

###################################################################################################


// LOGIN
if($function=='memberslogin')
{
    $loginpassed = FALSE;
    initvar('username');
    initvar('password');
    if($plugin_cf['memberpages']['show_fullname']) initvar('fullname');
    if(isset($_COOKIE['cookname']) && isset($_COOKIE['cookpass']))
    {
        $username = $_COOKIE['cookname'];
        $password_hash = $_COOKIE['cookpass'];
        $autologin = true;
    }
    else
    {
        $password_hash = memberpages_Hash($password);
        $autologin = false;
    }

    foreach ($member as $i=>$value) {

        if($username == $member[$i]['user'] && $password_hash == memberpages_Hash($member[$i]['pass'])) {

            if($plugin_cf['memberpages']['show_expires']
                && $member[$i]['expires']
                && $member[$i]['expires'] < time()) {
                if(isset($_COOKIE['cookname']) && isset($_COOKIE['cookpass'])) {
                    setcookie("cookname", "", 1, "/");
                    setcookie("cookpass", "", 1, "/");
                }

                memberpages_LogEntry(" $username rejected: membership expired");

                $loginpassed = TRUE;

                //If an expired page is defined use it
                if($plugin_tx['memberpages']['page_on_expired']) {
                    header('Location: '.CMSIMPLE_URL.'?'.$plugin_tx['memberpages']['page_on_expired']);
                    exit;
                } else {
                    $o .= '<div class="membp_message">'.$plugin_tx['memberpages']['notice_membership_expired'].'</div>';
                }
                break;

            } else {
                if($autologin) $_SESSION['autologin']=1;
                $_SESSION['accesslevel'] = $member[$i]['access'];
                $_SESSION['username'] = $username;
                $_SESSION['password'] = $password_hash;
                if($plugin_cf['memberpages']['show_fullname']) {
                    $_SESSION['fullname'] = $member[$i]['full']? $member[$i]['full'] : $username;
                }
                if($plugin_cf['memberpages']['show_expires']) {
                    $_SESSION['expires'] = $member[$i]['expires']? $member[$i]['expires'] : '';
                }
                memberpages_LogEntry("$username logged in");

                $loginpassed = TRUE;

                //If a login_page is defined use it
                if($plugin_cf['memberpages']['VIP_level']
                    && $plugin_tx['memberpages']['page_on_VIP_login']
                    && $_SESSION['accesslevel'] >= $plugin_cf['memberpages']['VIP_level']) {

                    header('Location: '.CMSIMPLE_URL.'?'.$plugin_tx['memberpages']['page_on_VIP_login']);
                    exit;

                } else if($plugin_tx['memberpages']['page_on_login']) {

                    header('Location: '.CMSIMPLE_URL.'?'.$plugin_tx['memberpages']['page_on_login']);
                    exit;

                } else {
                    header('Location: '.CMSIMPLE_URL.'?'.$su);
                    exit;
                }
            }
            break;
        }
    }
    if(!$loginpassed) {

        if(isset($_COOKIE['cookname']) && isset($_COOKIE['cookpass']))
        {
            setcookie("cookname", "", 1, "/");
            setcookie("cookpass", "", 1, "/");
        }

        memberpages_LogEntry($username . ' wrong name/password');

        //If an error_page is defined, use it
        if($plugin_tx['memberpages']['page_on_error'])
        {
            header('Location: '.CMSIMPLE_URL.'?'.$plugin_tx['memberpages']['page_on_error']);
            exit;
        }
        //else give an error message
        else
        {
            $o .= '<div class="membp_message">'.$plugin_tx['memberpages']['notice_login_error'].'</div>';
        }
    }
}


if($function=='autologin')
{
    setcookie("cookname", $_SESSION['username'], time()+60*60*24*100, "/");
    setcookie("cookpass", $_SESSION['password'], time()+60*60*24*100, "/");
    $_SESSION['autologin'] = 1;
}

###################################################################################################

// LOGOUT

if($function=='memberslogout')
{
    $username = isset($_SESSION['username'])? $_SESSION['username'] : '???';
    unset($_SESSION['username'], $_SESSION['accesslevel'], $_SESSION['password'], $_SESSION['fullname'], $_SESSION['autologin']);
    if(isset($_COOKIE['cookname']) || isset($_COOKIE['cookpass']))
    {
        setcookie("cookname", "", time()-60*60*24*100, "/");
        setcookie("cookpass", "", time()-60*60*24*100, "/");
    }
    memberpages_LogEntry($username .' logged out');

    //If a logout_page is defined, use it
    if($plugin_tx['memberpages']['page_on_logout'])
    {
        header('Location: '.CMSIMPLE_URL.'?'.$plugin_tx['memberpages']['page_on_logout']);
        exit;
    }
    //else give a message
    else
    {
        $o .= '<div class="membp_message">'.$plugin_tx['memberpages']['notice_logged_out'].'</div>';
    }
}


###################################################################################################

// Members Control Panel for changing password and email address

if($function=='memberspanel' || $function=='savepaneldata') $o .= memberpages_MembersPanel();
 

##################################################################################################


// FUNCTIONS



function memberpages_LogEntry($entry)
{
    global $pth;
    $log = fopen(MEMBERSFILEPATH . 'log.txt', 'a');
    fwrite($log, date("Y-m-d H:i:s") . ' ' . $entry . "\n");
    fclose($log);
}



function memberpages_Mail($to, $subject, $message)
{
    global $plugin_cf;

    $subject = '=?UTF-8?B?'.base64_encode($subject).'?=';
    $header = "MIME-Version: 1.0\r\nContent-type: text/plain; charset=UTF-8\r\nFrom: "
            . $plugin_cf['memberpages']['site_email'];
    return mail($to, $subject, $message, $header);
}



function memberpages_Hash($item)
{
    global $cf;
    if(function_exists('hash')) return hash('sha256',$cf['security']['password'].$item,true);
    else return sha1($cf['security']['password'].$item,true);
}



function memberslogin($membersnotice=false)
{
    global $sn,$su,$plugin_cf,$plugin_tx,$tx;
    $o = '';

    if(!isset($_SESSION['username']))
    {
        if($plugin_cf['memberpages']['small_login'])
        {
           $o .= "<a class='membp_not_clicked' style='cursor:pointer;margin:-3px;padding:3px;display:block;' id='small_memberpages_Login'
             onClick=\"
             if (document.getElementById('small_memberpages_Login').className == 'membp_not_clicked') {
               document.getElementById('small_memberpages_Login').className = 'membp_clicked';
               document.getElementById('memberpages_Login').style.display = 'block';
             } else {
               document.getElementById('small_memberpages_Login').className = 'membp_not_clicked';
               document.getElementById('memberpages_Login').style.display = 'none';
             }\">" . $plugin_tx['memberpages']['log_in_small'] .'</a>';
            $o .= '<div id="memberpages_Login">';
        }
        $o .= "\n"
           .  '<form action="'.$sn.'?'.$su.'" method="post">'
           .  "\n"
           .  tag('input type="hidden" name="function" value="memberslogin"')
           .  "\n"
           .  $plugin_tx['memberpages']['memberslist_username']
           .  tag('br')
           .  "\n"
           .  tag('input type="text" name="username" class="membp_member" tabindex="1"')
           .  tag('br')
           .  "\n"
           .  $plugin_tx['memberpages']['memberslist_password'];
        $o .= tag('br')
           .  "\n"
           .  tag('input type="password" name="password" class="membp_member" tabindex="2"')
           .  tag('br')
           .  "\n"
           .  '<button type="submit" name="submit" class="membp_member_button" value="1" tabindex="3">'
           .  $plugin_tx['memberpages']['log_in'] . '</button>';

        if($plugin_cf['memberpages']['passwordforgotten'] && $plugin_cf['memberpages']['site_email'])
        {
            $o .= ' <button type="submit" name="password_forgotten" value="1" class="membp_small_button" tabindex="5">'
               .  $plugin_tx['memberpages']['passwordforgotten'] . '</button>';
        }
        if($plugin_cf['memberpages']['registerme'])
        {
            $o .= tag('br')
               .  '<button type="submit" name="register_me" value="1" class="membp_registerme" tabindex="6">'
               .  $plugin_tx['memberpages']['registerme'] . '</button>';
        }
        $o .= '</form>'."\n"."\n";
        if($plugin_cf['memberpages']['small_login'])
        {
            $o .=  '</div><script type="text/javascript">
                // <![CDATA[
                    document.getElementById(\'memberpages_Login\').style.display = \'none\';
                 // ]]>
                </script>';
        }
    }
    else
    {
        $o = $membersnotice
            ? '<p>'.$plugin_tx['memberpages']['logged_in'].'</p>'
            : loggedinform();
    }
    return $o;
}


function loggedinform ($oneline=false)
{
    global $sn,$su,$plugin_cf,$plugin_tx,$tx,$pth,$function;

    $name =  sprintf($plugin_tx['memberpages']['notice_loggedin'], $_SESSION['username']);

    if($plugin_cf['memberpages']['show_expires']
        && $plugin_cf['memberpages']['warning_time']
        && $_SESSION['expires']
        && ($_SESSION['expires'] - $plugin_cf['memberpages']['warning_time'] * 86400 ) < time()) {
        $warning = '<span class="membp_warning">';
        $warning .=  $oneline
            ? $plugin_tx['memberpages']['memberslist_expires'] .' ' . date("d.m.Y",$_SESSION['expires']) .'.'
            : sprintf($plugin_tx['memberpages']['warning_text'],date("d.m.Y",$_SESSION['expires']));
        $warning .=  '</span>';
    } else $warning = '';

    if($plugin_cf['memberpages']['show_actives']) {
        $actives =  $plugin_tx['memberpages']['notice_active_members'] . ': ' . memberlist(true);
    } else $actives = '';

    if($plugin_cf['memberpages']['rememberme'] && isset($_SESSION['autologin'])) {

        $lg = '<form action="'.$sn.'?'.$su.'" method="post">'
           .  tag('input type="hidden" name="function" value="autologin"')
           .  '<button type="submit" class="membp_buttonpressed">'
           .  $plugin_tx['memberpages']['log_in_remember_me'].'</button>'
           .  '</form>';

        $lg .= '<form style="display:inline;" action="'.$sn.'?'.$su.'" method="post">'
             . tag('input type="hidden" name="function" value="memberslogout"')
             . '<button type="submit" style="white-space:normal;">';
        $lg .= $oneline
             ? $plugin_tx['memberpages']['log_out']
             : $plugin_tx['memberpages']['log_out_no_remember'];
        $lg .= '</button></form>';
        if(!$oneline) $lg .= tag('br') . tag('br') . "\n";

    } else {

        $lg ='<form style="display:inline;" action="'.$sn.'?'.$su.'" method="post">'
           . tag('input type="hidden" name="function" value="memberslogout"')
           . '<button type="submit">'.$plugin_tx['memberpages']['log_out'].'</button>'
           . '</form>';
        if(!$oneline) $lg .= tag('br') . tag('br') . "\n";

        if($plugin_cf['memberpages']['rememberme'])
        {
            $lg .= '<form action="'.$sn.'?'.$su.'" method="post">'
               .  tag('input type="hidden" name="function" value="autologin"')
               .  '<button type="submit" style="white-space:normal;">'
               .  $plugin_tx['memberpages']['log_in_remember_me'].'</button>'
               .  '</form>';
        }
    }

    if($plugin_cf['memberpages']['controlpanel']) {
        $cp = '<form action="'.$sn.'?'.$su.'" method="post">';
        $text = $oneline
            ? ' — '. $_SESSION['username'] . ' — '
            : $plugin_tx['memberpages']['member_control_panel'];
        $cp .= $function == 'memberspanel' || $function == 'savepaneldata'
           ?  tag('input type="hidden" name="function" value="closepanel"')
           .  '<button type="submit" class="membp_buttonpressed">'
           .  $text . '</button>'
           :  tag('input type="hidden" name="function" value="memberspanel"')
           .  '<button type="submit">'
           .  $text . '</button>';
        $cp .='</form>';

    } else $cp = '';

    return $oneline
        ? '<div class="membp_oneline">'.$cp.$lg.' '.$warning.' '.$actives.'</div>'
        : $name.$warning.tag('br').$actives.tag('br').$lg.$cp;
}



function membersnotice($oneline=false)
{
    return isset($_SESSION['username'])
    ? loggedinform($oneline)
    : '';
}



function memberpages_HidePages()
{
    global $pd_router,$pth,$adm,$edit,$plugin_cf,$c;

    // Add used interests to router
    $pd_router -> add_interest('mpage');
    $pd_router -> add_interest('mplevel');

    // tab for admin-menu
    $pd_router -> add_tab('M', $pth['folder']['plugins'].'memberpages/memberpages_view.php');

    // MAIN PLUGIN-FUNCTION: hide memberpages unless a member is logged in or CMS is in edit or adm mode

    if(!$adm OR ($adm && !$edit))
    {
        $pages = $pd_router -> find_all();
        foreach($pages as $i => $values)
        {
            if(isset($values['mpage']) && $values['mpage'])
            {
                if($values['mplevel'])
                {
                    $access_level = $values['mplevel'];

                    if(!$plugin_cf['memberpages']['accessmode'])
                    {
                        if(!isset($_SESSION['accesslevel']))
                        {
                            $c[$i] = '#CMSimple hide#';
                        }
                    }
                    elseif($plugin_cf['memberpages']['accessmode']==1)
                    {
                        if(!isset($_SESSION['accesslevel'])
                           || $_SESSION['accesslevel'] < $access_level)
                        {
                            $c[$i] = '#CMSimple hide#';
                        }
                    }
                    elseif($plugin_cf['memberpages']['accessmode']==2)
                    {
                        if(!isset($_SESSION['accesslevel'])
                             || $_SESSION['accesslevel'] != $access_level)
                        {
                            $c[$i] = '#CMSimple hide#';
                        }
                    }
                    elseif($plugin_cf['memberpages']['accessmode'] > 2)
                    {
                        if(!isset($_SESSION['accesslevel'])
                           || !($_SESSION['accesslevel'] & pow(2,$access_level-1)))
                        {
                            $c[$i] = '#CMSimple hide#';
                        }
                    }
                }
                else
                {
                    if(!isset($_SESSION['accesslevel']))
                    {
                        $c[$i] = '#CMSimple hide#';
                    }
                }
            }
        }
    }
}



function memberpages_PwForgotten()
{
    global $function,$member,$plugin_tx,$plugin_cf;

    $o = $function = $log = $answer = $name = $email = '';
    $ok = false;

    // ========================= Sending the password =========================
    if(isset($_POST['pwforgotten']))
    {
        $name    = isset($_POST['name_pwforgotten'])  ? trim(stsl(XH_hsc($_POST['name_pwforgotten'])))    : '';
        $email   = isset($_POST['email_pwforgotten']) ? stsl(XH_hsc($_POST['email_pwforgotten']))   : '';

        if(!$name) {
            $answer .= '<ul><li>'.$plugin_tx['memberpages']['passwordforgotten_no_name'].'</li></ul>';
        } else {

            $found_key = false;
            foreach ($member as $key => $value) {
                if( $name == $member[$key]['user']
                    && $name
                    && $member[$key]['user']
                    && $member[$key]['email']) {
                    $found_key = $key;
                    break;
                }
            }
            // prepare sending of mail
            if($found_key!==false) {
                $to = $member[$found_key]['email'];
                $message = sprintf($plugin_tx['memberpages']['passwordforgotten_email_message'],
                                   $member[$found_key]['user'],CMSIMPLE_URL,$member[$found_key]['pass']);
            } else {
            // in case no member's email or no member's name was found
                $log .= "pw asked by $name, name not found — ";

                // send mail to site address/webmaster
                $to = $plugin_cf['memberpages']['admin_email'];
                $message = sprintf($plugin_tx['memberpages']['passwordforgotten_webmaster_inform'], CMSIMPLE_URL,$name);
                if($email) $message .= "\n\n"
                                     . $plugin_tx['memberpages']['passwordforgotten_webmaster_inform_email']
                                     . ': '.$email;
            }

            $subject = $plugin_tx['memberpages']['passwordforgotten_email_subject'];

            if(memberpages_Mail($to,$subject,$message)) {

                $answer .= $found_key!==false
                        ? $plugin_tx['memberpages']['passwordforgotten_send']
                        : $plugin_tx['memberpages']['passwordforgotten_webmaster_contacted'] ;

                $log .= $found_key!==false
                    ? 'pw send to '.$member[$found_key]['user'].' at '.$member[$found_key]['email']
                    : "pw request by $name sent to $to ";
                $ok = true;

            } else {

                $answer =  sprintf($plugin_tx['memberpages']['passwordforgotten_could_not_send'],$plugin_cf['memberpages']['admin_email']);
                $log .= "pw asked by $name, mail function failed ";
            }

            // writing to log file
            if($log) memberpages_LogEntry($log);
        }
    }

    //========================= Form for asking for the forgotten password to be send ============================
    $o .= '<div class="membp_message" id="pwforgotten">'
       . $plugin_tx['memberpages']['notice_password_forgotten'];

    if($answer) $o .= "\n" . '<div>' ."\n"
                    .  $answer
                    . '</div>' . "\n" ;

    $o .= '<form action="" method="post">'
       . tag('input type="hidden" name="password_forgotten" value="1"')
       . '<table class="membp_memberspanel">';

    if(!$ok) {
       $o .= '<tr>'
       .  '<td style="text-align:center">'
       .  $plugin_tx['memberpages']['passwordforgotten_name']
       .  ' </td><td>'
       .  tag('input type="text" maxlength="20" name="name_pwforgotten" value="'.$name.'"')
       .  '</td>'
       .  '</tr>' . "\n"
       .  '<td style="text-align:center">'
       .  $plugin_tx['memberpages']['passwordforgotten_email']
       .  ' </td><td>'
       .  tag('input type="text" maxlength="60" name="email_pwforgotten" value="'.$email.'"')
       .  '</td>'
       .  '</tr>' . "\n"

       .  '<tr><td>&nbsp;</td><td>&nbsp;</td></tr>'

       .  '<tr><td colspan="2" class="membp_justify">'
       .  $plugin_tx['memberpages']['passwordforgotten_text']
       .  "</td></tr>\n";
    }

     $o .= $ok
       ?  '<tr><td colspan="2">' . tag('br')
       .  tag('input type="button" value="'.$plugin_tx['memberpages']['close']
       .  '" onclick="document.getElementById(\'pwforgotten\').style.display = \'none\';"')
       .  '</td></tr>' . "\n"
       :  '<tr><td>'
       .  '<button type="submit" name="stoppwforgotten"'
       .  ' onclick="document.getElementById(\'pwforgotten\').style.display = \'none\';">'
       .  $plugin_tx['memberpages']['close']
       .  '</button></td><td>'
       .  '<button type="submit" name="pwforgotten">'
       .  $plugin_tx['memberpages']['passwordforgotten_send_password']
       .  '</button></td></tr>' . "\n";

    $o .= '</table></div>' . "\n";

    return $o;
}



function memberpages_RegisterMe()
{
    global $function,$member,$plugin_tx,$plugin_cf,$pth;

    $function = $answer = $username = $email = $email2 = $fullname = $comment = $log = '';
    $ok = false;

    // ========================= receiving the registration request =========================

    if(isset($_POST['register']))
    {
        $ok = true;
        $username = isset($_POST['username']) ? trim(stsl(XH_hsc(str_replace(array('"','\\'),'',$_POST['username'])))) : '';
        $email    = isset($_POST['email'])    ? stsl(XH_hsc(str_replace(array('"','\\'),'',$_POST['email'])))    : '';
        $email2   = isset($_POST['email2'])   ? stsl(XH_hsc(str_replace(array('"','\\'),'',$_POST['email2'])))   : '';
        $fullname = isset($_POST['fullname']) ? trim(stsl(XH_hsc(str_replace(array('"','\\'),'',$_POST['fullname'])))) : '';
        $comment  = isset($_POST['comment'])  ? stsl(XH_hsc(str_replace(array('"','\\'),'',$_POST['comment'])))  : '';

        if(!$username) {
            $answer .= '<ul><li>'.$plugin_tx['memberpages']['register_username_missing'].'</li></ul>';
            $ok = false;
        }
        if($username && mb_strlen($username,'UTF-8')<3) {
            $answer .= '<ul><li>'.$plugin_tx['memberpages']['register_username_too_short'].'</li></ul>';
            $ok = false;
        }
        if($username && strpos($username, ' ')) {
            $answer .= '<ul><li>'.$plugin_tx['memberpages']['register_username_has_space'].'</li></ul>';
            $ok = false;
        }
        if(!$email) {
            $answer .= '<ul><li>'.$plugin_tx['memberpages']['register_email_missing'].'</li></ul>';
            $ok = false;
        }
        if($email != $email2) {
            $answer .= '<ul><li>'.$plugin_tx['memberpages']['register_email_not_matching'].'</li></ul>';
            $ok = false;
            $email = $email2 = '';
        }
        if($email && $email==$email2 && !preg_match('/^.+@\S+$/u',$email)) {
            $answer .= '<ul><li>'.$plugin_tx['memberpages']['register_email_no_email'].'</li></ul>';
            $ok = false;
        }
        foreach ($member as $key=>$value) {
            if($username==$member[$key]['user']) {
                $answer .= '<ul><li>'.$plugin_tx['memberpages']['register_username_taken'].'</li></ul>';
                $ok = false;
                break;
            }
            if($fullname && $fullname==$member[$key]['full']) {
                $answer .= '<ul><li>'.$plugin_tx['memberpages']['register_fullname_taken'].'</li></ul>';
                $ok = false;
                break;
            }
        }

        if($ok) {
            $to = $plugin_cf['memberpages']['admin_email']
                ? $plugin_cf['memberpages']['admin_email']
                : $plugin_cf['memberpages']['site_email'];

            $message = sprintf($plugin_tx['memberpages']['register_via_webmaster'], $username, $fullname, $email, $comment);
            $subject = $plugin_tx['memberpages']['register_email_subject'];

            if(memberpages_Mail($to,$subject,$message)) {

                $answer .= $plugin_tx['memberpages']['register_sent'] . tag('br')
                         . $plugin_tx['memberpages']['memberslist_username'] . ' = ' . $username  . tag('br')
                         . $plugin_tx['memberpages']['memberslist_email'] . ' = ' . $email;
                if($fullname) $answer .= tag('br') . $plugin_tx['memberpages']['memberslist_fullname'] . ' = '  . $fullname;
                if($comment)  $answer .= tag('br') . $plugin_tx['memberpages']['memberslist_comment'] . ' = '   . $comment;
                $log .= "registration asked by $username ($fullname) at $email ";
                file_put_contents(MEMBERSFILEPATH
                    . 'new.php','['. date("Y-m-d H:i:s") .']' . PHP_EOL
                    . 'name = "' . $username . '"' . PHP_EOL
                    . 'fullname = "' . $fullname . '"' . PHP_EOL
                    . 'email = "' . $email . '"' . PHP_EOL
                    . 'comment = "' . $comment . '"' . PHP_EOL, FILE_APPEND | LOCK_EX);

            } else {

                $answer .= $plugin_tx['memberpages']['register_failed'] .' '. $to ;
                $log .= "registration asked by $username ($fullname) at $email, mail function failed ";
                $ok = false;
            }
            memberpages_LogEntry($log);
        }
    }

    //================================ register me display ======================================
    $o = '<div class="membp_message" id="register_me">'.$plugin_tx['memberpages']['register_headline'];

    $o .= '<form action="" method="post">'
      . tag('input type="hidden" name="register_me" value="1"');

    if($answer) $o .= "\n" . '<div>' ."\n"
                    .  $answer
                    . '</div>' . "\n" ;

    if(!$ok) {
        $o .='<table class="membp_memberspanel">'
           . '<tr>'
           . '<td style="text-align:center">'
           . $plugin_tx['memberpages']['register_username']
           . ' </td><td>'
           . tag('input type="text" name="username" maxlength="20" value="'.$username.'"')
           . '</td>'
           . '</tr>' . "\n"

           . '<tr>'
           . '<td style="text-align:center">'
           . $plugin_tx['memberpages']['register_email']
           . ' </td><td>'
           . tag('input type="text" name="email" maxlength="60" value="'.$email.'"')
           . '</td>'
           . '</tr>' . "\n"
           . '<tr>'
           . '<td style="text-align:center">'
           . $plugin_tx['memberpages']['register_email2']
           . ' </td><td>'
           . tag('input type="text" name="email2" value="'.$email2.'"')
           . '</td>'
           . '</tr>' . "\n"

           . '<tr>'
           . '<td style="text-align:center">'
           . $plugin_tx['memberpages']['register_fullname']
           . ' </td><td>'
           . tag('input type="text" name="fullname" maxlength="60" value="'.$fullname.'"')
           . '</td>'
           . '</tr>' . "\n"

           . '<tr>'
           . '<td style="text-align:center">'
           . $plugin_tx['memberpages']['register_comment']
           . ' </td><td>'
           . '<textarea name="comment" style="height:3em;width:100%;">' . $comment . '</textarea>'
           . '</td>'
           . '</tr>' . "\n"

           . '<tr><td colspan="2">'
           . $plugin_tx['memberpages']['register_pw_by_webmaster'];

        if($plugin_cf['memberpages']['controlpanel']) {
            $o .= ' ' . $plugin_tx['memberpages']['register_pw_change'];
        }

        $o .=  "</td></tr>\n";
    }

    $o .=  $ok
        ?  '<tr><td colspan=2>' . tag('br')
        .  tag('input type="submit" name="stopregister_me" value="'.$plugin_tx['memberpages']['close']
        .  '" onclick="document.getElementById(\'register_me\').style.display = \'none\';"')
        . ' </td>'
        : '<tr><td>'
        .  '<button type="submit" name="stopregister_me"'
        .  ' onclick="document.getElementById(\'register_me\').style.display = \'none\';">'
        .  $plugin_tx['memberpages']['close']
        . '</button></td><td>'
        . '<button type="submit" name="register">'.$plugin_tx['memberpages']['register'].'</button>'
        . '</td>';

    $o .= '</tr>' . "\n" . '</table>' . "\n" . '</form>' . "\n" . '</div>';

    return $o;
}



function memberpages_MembersPanel()
{
    global $pth,$plugin_cf,$plugin_tx;
    $member = parse_ini_file(MEMBERSFILEPATH.'membersfile.php',true);
    $o = $answer = $oldpassword = $newpassword = $newpassword2 = $newemail = $newfullname = '';
    $i = false;
    foreach ($member as $key=>$value) {
         if($_SESSION['username']==$member[$key]['user']) {
            $i = $key;
            break;
         }
    }
    if($i === false) return false;

    $ok = $systemfault = false;
    $not_ok_detail = $change = '';
    $nothingnew = true;
    $passwordlength = $plugin_cf['memberpages']['generate_password'] > 2
        ? ($plugin_cf['memberpages']['generate_password'] + 2)
        : 5;

    // ======================== processing received changes =================================
    if(isset($_POST['function']) && $_POST['function']=='savepaneldata')
    {
        $oldpassword    = isset($_POST['oldpassword'])  ? stsl($_POST['oldpassword'])       : '';
        $newpassword    = isset($_POST['newpassword'])  ? stsl($_POST['newpassword'])       : '';
        $newpassword2   = isset($_POST['newpassword2']) ? stsl($_POST['newpassword2'])      : '';
        $newemail       = isset($_POST['newemail'])     ? trim(stsl($_POST['newemail']))    : '';
        $newfullname    = isset($_POST['newfullname'])  ? str_replace('"','',trim(stsl($_POST['newfullname']))) : '';

        $pw_found          = $oldpassword? true : false;
        $pw_wrong          = ($pw_found && $member[$i]['pass'] != $oldpassword)? true : false;
        $newpw_notmatching = $newpassword && $newpassword != $newpassword2 ? true : false;
        $newpw_too_short   = $newpassword && mb_strlen($newpassword,'UTF-8') < $passwordlength? true : false;
        $newpw_too_simple  = $newpassword && !preg_match('!^.*(?=.*[\p{Lu}]).*(?=.*[\p{Ll}]).*(?=.*[\p{N}]).*$!u',$newpassword) ? true : false;
        $newpw_forb_chars  = $newpassword && !preg_match('!^[^\"\\\\]*$!u',$newpassword) ? true : false;

        if($newpassword && !$newpw_notmatching && !$newpw_too_short && !$newpw_too_simple && !$newpw_forb_chars
            && !$newpw_notmatching && $member[$i]['pass'] != $newpassword)
            $change .= $plugin_tx['memberpages']['new_password'] . tag('br') . tag('br');
        if($newpassword && $member[$i]['pass'] != $newpassword) $nothingnew = false;


        $newemail_not_ok   = ($newemail && !preg_match('!^[^\r\n|,]+@[^\s|;|{|}|,]+$!',$newemail))? true : false;
        if(!$newemail_not_ok && $newemail && $newemail != $member[$i]['email'])
            $change .= $plugin_tx['memberpages']['new_email'] . tag('br') . tag('br');
        if($newemail && $member[$i]['email'] != $newemail) $nothingnew = false;

        $fullname_not_ok   = ($newfullname && !preg_match('!^[^\r\n|;|{|}|<|>|,]*$!',$newfullname))? true : false;
        if($newfullname && !$fullname_not_ok && $newfullname != $member[$i]['full'])
            $change .= $plugin_tx['memberpages']['new_full_name'] . tag('br') . tag('br');
        if($newfullname && $member[$i]['full'] != $newfullname) $nothingnew = false;


        if($pw_found && !$pw_wrong && !$newpw_notmatching && !$newpw_too_short && !$newpw_forb_chars
            && !$newpw_too_simple && !$newemail_not_ok && !$fullname_not_ok && !$nothingnew) {

            $newpassword = $newpassword? $newpassword : $oldpassword;

            $member[$i]['full'] = $newfullname;
            if($newpassword) {
                $member[$i]['pass'] = $newpassword;
                $member[$i]['x'] = 1;
            }  
            $member[$i]['email']    = $newemail;
            if(memberpages_SaveList($member)) {
                $ok = true;
                if($newpassword) $_SESSION['password'] = $newpassword;
                if($newfullname != $_SESSION['fullname']) {
                    $_SESSION['fullname'] = $newfullname;
                } 
            } else {
                $sytemfault = true;
            }

        }

        $answer  .= "\n<div>\n$change";

        if ($systemfault)       $answer .= $plugin_tx['memberpages']['error_systemfault_memberspanel']
                                        .  tag('br') . tag('br');
        if (!$pw_found)         $answer .= $plugin_tx['memberpages']['error_password_not_entered']
                                        .  tag('br') . tag('br');
        if ($pw_wrong)          $answer .= $plugin_tx['memberpages']['error_wrong_password']
                                        .  tag('br') . tag('br');
        if ($newpw_notmatching) $answer .= $plugin_tx['memberpages']['error_passwords_not_matching']
                                        .  tag('br') . tag('br');
        if ($newpw_too_short)   $answer .= $plugin_tx['memberpages']['error_password_too_short']
                                        .  tag('br') . tag('br');
        if ($newpw_too_simple)  $answer .= $plugin_tx['memberpages']['error_password_too_simple']
                                        .  tag('br') . tag('br');
        if ($newpw_forb_chars)  $answer .= $plugin_tx['memberpages']['error_password_forbidden_chars']
                                        .  tag('br') . tag('br');
        if ($newemail_not_ok)   $answer .= $plugin_tx['memberpages']['error_email_wrong']
                                        .  tag('br') . tag('br');
        if ($fullname_not_ok)   $answer .= $plugin_tx['memberpages']['error_fullname_wrong']
                                        .  tag('br') . tag('br');
        if ($nothingnew)        $answer .= $plugin_tx['memberpages']['error_no_change_detected']
                                        .  tag('br') . tag('br');

        $answer .= $ok
                ? $plugin_tx['memberpages']['notice_data_successful_changed']
                : $plugin_tx['memberpages']['notice_data_not_changed'];
        $answer .= "\n</div>\n";

        // writing to log file
        if($ok) memberpages_LogEntry($_SESSION['username'] . ' changed his/her data');

    }

    // ============================== Members control panel entry form ==============================


        $o .= '<div class="membp_message" id="memberspanel">'
           . sprintf($plugin_tx['memberpages']['member_control_panel_greeting'],$_SESSION['username']);

    if($answer) $o .= $answer;

        $o .= '<form action="" method="post">'
           . '<table class="membp_memberspanel">';

    if(!$ok) {
       $o .= '<tr><td>'
           . $plugin_tx['memberpages']['member_old_password']
           . ' </td><td>'
           . tag('input type="text" name="oldpassword" value="'.$oldpassword.'"')
           . "</td></tr>\n"
           . '<tr><td>'
           . sprintf($plugin_tx['memberpages']['member_new_password1'],$passwordlength)
           . ' </td><td>'
           . tag('input type="text" name="newpassword" value="'.$newpassword.'"')
           . "</td></tr>\n"
           . '<tr><td>'
           . $plugin_tx['memberpages']['member_new_password2']
           . ' </td><td>'
           . tag('input type="text" name="newpassword2" value="'.$newpassword2.'"')
           . "</td></tr>\n"
           . '<tr><td>'
           . $plugin_tx['memberpages']['member_new_email']
           . tag('br');


        $o .= $newemail
           ?  '</td><td>'
           .  tag('input type="text" name="newemail" value="'.$newemail.'"')
           .  "</td></tr>\n"
           :  '</td><td>'
           .  tag('input type="text" name="newemail" value="'.$member[$i]['email'].'"')
           .  '</td><tr>' . "\n";

        if($plugin_cf['memberpages']['show_fullname']) {
            $o .= $newfullname
               ?  '<tr><td>' . $plugin_tx['memberpages']['notice_your_fullname_is'] . '</td><td>'
               .  tag('input type="text" value="'.$newfullname.'" name="newfullname"')
               .  '</td><tr>'."\n"
               :  '<tr><td>' . $plugin_tx['memberpages']['notice_your_fullname_is'] . '</td><td>'
               .  tag('input type="text" value="'.$member[$i]['full'].'" name="newfullname"')
               .  '</td><tr>' . "\n";
        }
    }

    $o .= $ok
       ?  '<tr><td colspan="2">' . tag('br')
       .  '<button type="submit" name="function" value="0">'.$plugin_tx['memberpages']['close'].'</button>'
       .  '</td></tr>' . "\n"
       :  '<tr><td>'
       .  '<button type="submit" name="function" value="0">'.$plugin_tx['memberpages']['close'].'</button>'
       .  '</td><td>'
       .  '<button type="submit" name="function" value="savepaneldata">'.$plugin_tx['memberpages']['save_settings'].'</button>'
       .  '</td></tr>' . "\n";

    $o .= '</table>' . "\n" . '</form>'. "\n" . '</div>';

    return $o;
}


function memberpages_SaveList($member)
{
    $file = ';<?php' . PHP_EOL . ';die();' . PHP_EOL . ';/*' . PHP_EOL;
    $i = 0;
    foreach ($member as $value) {
        $file .= "[$i]" . PHP_EOL
              .  'user = "'.   $value['user'].'"'. PHP_EOL
              .  'pass = "'.   $value['pass'].'"'. PHP_EOL
              .  'access = "'. $value['access'].'"'. PHP_EOL
              .  'email = "'.  $value['email'].'"'. PHP_EOL
              .  'full = "'.   $value['full'].'"'. PHP_EOL
              .  'expires = "'.$value['expires'].'"'. PHP_EOL
              .  'x = "'.      $value['x'].'"'. PHP_EOL;
        $i ++;
    }
    if(file_put_contents(MEMBERSFILEPATH.'membersfile.php',$file,LOCK_EX) !== false) {
        if (function_exists('opcache_invalidate')) {
            opcache_invalidate(MEMBERSFILEPATH.'membersfile.php');
        }
        return true;
    }
    else return false;
}